<?php

namespace FiloBlu\ScratchAndWin\Controller\Adminhtml\ScratchAndWin;

use Magento\Backend\App\Action;

class Details extends \Magento\Backend\App\Action
{
    /**
     * Core registry
     *
     * @var \Magento\Framework\Registry
     */
    protected $_coreRegistry = null;

    /**
     * @var \Magento\Framework\View\Result\PageFactory
     */
    protected $resultLayoutFactory;

    protected $scratchAndWin;

    /**
     * @param Action\Context $context
     * @param \Magento\Framework\View\Result\PageFactory $resultPageFactory
     * @param \Magento\Framework\Registry $registry
     */
    public function __construct(
        Action\Context $context,
        \Magento\Framework\View\Result\LayoutFactory $resultLayoutFactory,
        \Magento\Framework\Registry $registry,
        \FiloBlu\ScratchAndWin\Model\ScratchAndWinFactory $scratchAndWin
    )
    {
        $this->resultLayoutFactory = $resultLayoutFactory;
        $this->_coreRegistry = $registry;
        $this->scratchAndWin = $scratchAndWin;
        parent::__construct($context);
    }

    /**
     * {@inheritdoc}
     */
    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('FiloBlu_ScratchAndWin::config');
    }

    /**
     * Edit ScratchAndWin
     *
     * @return \Magento\Backend\Model\View\Result\Page|\Magento\Backend\Model\View\Result\Redirect
     * @SuppressWarnings(PHPMD.NPathComplexity)
     */
    public function execute()
    {
        $id = $this->getRequest()->getParam('id');

        $model = $this->scratchAndWin->create();

        if ($id) {
            $model->load($id);
            if (!$model->getId()) {
                $this->messageManager->addError(__('This ScratchAndWin no longer exists.'));
                /** \Magento\Backend\Model\View\Result\Redirect $resultRedirect */
                $resultRedirect = $this->resultRedirectFactory->create();

                return $resultRedirect->setPath('*/*/');
            }
        }

        $this->_coreRegistry->register('filoblu_scratchandwin', $model);

        $resultLayout = $this->resultLayoutFactory->create();

        $detailsBlock = $resultLayout->getLayout()->getBlock('scratchandwin.edit.tab.details');
        if ($detailsBlock) {
            $detailsBlock->setScratchAndWinDetails($this->getRequest()->getPost('scratchandwin_details', null));
        }
        return $resultLayout;
    }
}
