<?php

namespace FiloBlu\ScratchAndWin\Controller\Get;

/**
 * Class ScratchAndWin
 * @package FiloBlu\ScratchAndWin\Controller\ScratchAndWin
 */
class Date extends \Magento\Framework\App\Action\Action
{

    /**
     * @var \Magento\Framework\Controller\Result\JsonFactory
     */
    protected $resultJsonFactory;
    
    /**
     * @var \Magento\Framework\Stdlib\DateTime\TimezoneInterface
     */
    protected $timezone;

    /**
     * @var \Magento\Framework\App\Request\Http
     */
    protected $request;

    /**
     * constructor.
     * @param \Magento\Framework\App\Action\Context $context
     */
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory,
        \Magento\Framework\Stdlib\DateTime\TimezoneInterface $timezone,
        \Magento\Framework\App\Request\Http $request
    )
    {
        parent::__construct($context);
        $this->resultJsonFactory = $resultJsonFactory;
        $this->timezone = $timezone;
        $this->request = $request;
    }

    /**
     * @return \Magento\Framework\App\ResponseInterface
     */
    public function execute()
    {
        if (!$this->request->isXmlHttpRequest()) {
            $resultRedirect = $this->resultFactory->setPath('*/');
            return $resultRedirect;
        }

        $result = $this->resultJsonFactory->create();

        try {
            return $result->setData(
                [
                    'day' => strtotime($this->timezone->date()->format('d-m-Y')),
                    'hour' => strtotime($this->timezone->date()->format('H:i:s'))
                ]
            );
        } catch (\Exception $e) {
            return $result->setData(['error' => __($e->getMessage())]);
        }
    }
}
