<?php

namespace FiloBlu\ScratchAndWin\Setup;

use Magento\Framework\Setup\UpgradeSchemaInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;

/**
 * Upgrade the Catalog module DB scheme
 */
class UpgradeSchema implements UpgradeSchemaInterface {

    /**
     * {@inheritdoc}
     */
    public function upgrade(SchemaSetupInterface $setup, ModuleContextInterface $context) {
                
        $setup->startSetup();

        if (version_compare($context->getVersion(), '1.0.1', '<')) {

            $connection = $setup->getConnection();

            $tableName = $setup->getTable('filoblu_scratchandwin_details');

            if ($connection->tableColumnExists($tableName, 'out_display_text') === false) {
                $connection->addColumn($tableName, 'out_display_text', array(
                    'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                    'default' => '',
                    'comment' => 'Text Out Image'
                ));
            }
            
            if ($connection->tableColumnExists($tableName, 'cursor_size') === false) {
                $connection->addColumn($tableName, 'cursor_size', array(
                    'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                    'default' => '',
                    'comment' => 'Cursor Size'
                ));
            }
            
            if ($connection->tableColumnExists($tableName, 'percentage') === false) {
                $connection->addColumn($tableName, 'percentage', array(
                    'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                    'default' => '',
                    'comment' => 'Scratch Percentage'
                ));
            }
            
            if ($connection->tableColumnExists($tableName, 'scratched_image') === false) {
                $connection->addColumn($tableName, 'scratched_image', array(
                    'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                    'default' => '',
                    'comment' => 'Scratch Image'
                ));
            }
            
        }

        $setup->endSetup();

    }

}
